From bb229287ba2f0d8f2f04d59002479163c2fcdf83 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jun 21 2017 13:41:17 +0000
Subject: [PATCH 877/1001] Don't use the fedmsg as a clock to check meeting time


---

diff --git a/hubs/widgets/meetings/__init__.py b/hubs/widgets/meetings/__init__.py
index 68c26b9..e8eec08 100644
--- a/hubs/widgets/meetings/__init__.py
+++ b/hubs/widgets/meetings/__init__.py
@@ -45,15 +45,23 @@ class BaseView(WidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         get_meetings = GetMeetings(instance)
+        now = datetime.datetime.utcnow()
+        meetings = {
+            title: meeting
+            for title, meeting in get_meetings().items()
+            if meeting['start_dt'] > now
+            }
         return dict(
             title=self.widget.label,
             calendar=instance.config["calendar"],
-            meetings=get_meetings(),
+            meetings=meetings,
             )
 
 
 class GetMeetings(CachedFunction):
 
+    TOPIC = ".fedocal.calendar."
+
     def execute(self):
         calendar = self.instance.config["calendar"]
         n_meetings = self.instance.config.get("n_meetings", 4)
@@ -81,18 +89,13 @@ class GetMeetings(CachedFunction):
         return meetings
 
     def should_invalidate(self, message):
-        # TODO -- first, if this is a fedocal widget, we need to just
-        # invalidate ourselves right away.
-
-        # second, check our old cache value and see if any of our meetings have
-        # passed by in time.
-        old_meetings = self.execute()
-        now = datetime.datetime.utcnow()
-        for title, meeting in old_meetings.items():
-            assert type(meeting['start_dt']) == type(now)
-            if meeting['start_dt'] < now:
-                return True
-        return False
+        if self.TOPIC not in message["topic"]:
+            return False
+        try:
+            calendar = message["msg"]["calendar"]["calendar_name"]
+        except KeyError:
+            return False
+        return (calendar == self.instance.config.get("calendar"))
 
 
 def next_meeting(meetings):

